%%% mon2017dev.cls ---      
%%
%%   LaTeX- (   vakthesis)
%%         ,
%%   ̳     12.01.2017  40
%% (  10.03.2017),
%% http://zakon.rada.gov.ua/go/z0155-17
%%
%%  :
%% --      ,
%% --        ,
%% --      
%%          ,
%% --        .
%%
%%     vakthesis:
%%   ,     .
%%
%%    
%% mon2017dev.tex, mon2017dev-intro.tex, mon2017dev-bib.tex, mon2017dev-app1.tex.
%%
%% TODO:
%%        .
%%  ,     .
%%      .
%%       :
%%
%% 1.  ,    
%%     ,    , --   ,
%%         ?
%%     ?
%%      ,    ?
%%      ,    ?
%%    ( ,   ,    .)
%%
%%       .
%%    ,  ,  . 2  ,     
%%           ,
%%      ()  ;
%%           ,
%%         ()  ,
%%        ( 2)    
%%    (  ).
%%
%% 2.        
%%          ,
%%      -- ,      , ,
%%          ?
%%                      
%%        쳿   
%%     
%%           
%%                      
%%
%% 3. ,     
%%         ,
%%          .
%%    ,   :
%%            ,
%%           ,
%%        ,
%%     ,       .
%%
%% 4.        :
%%    -- ,       ;
%%    -- ,     ;
%%    -- ,      .
%%
%%     ,   ,
%%               .
%%    ,     .
%%    ,  . 13  :
%%         ,
%%       4    
%%
%%         .
%%    ,        
%%    (bibtopic )?
%%
%% 5. ,      :
%%    --      (. 4 );
%%    --     (. 9);
%%    --   '    (. 13).
%%
%%           ?
%%     . 9  ,     
%%          ,   .
%%               
%%    (,     ,   vakthesis  ),
%%              .
%%     ,          .
%%           ,
%%         .
%%                 .
%%          ,
%%     ,          
%%    (       ,    ).
%%              ,
%%          .
%%        ,
%%    '       (multiply-defined labels),
%%       \bibitem      ,
%%        ,      .
%%
%%      ,      ,
%%       -- :
%%     --   ,
%%     --   .
%%    ,   ,    :
%%        (    ),
%%             .
%%    ,       ,   .
%%
%% 6. ,  
%%          
%%    (    ,      ).
%%         BibTeX-  
%%    ( Springer MathPhys Style,  ).
%%
%% 7.     
%%          .
%%       (,    )   .
%%     ,       LaTeX  .
%%
%% 8.        ( )  
%%    ( 4  ).
%%         .
%%     ,     LaTeX (oneside, twoside).
%%
%% 9.        ,
%%        --  ukrainian ( english  ).
%%      ,  '    .
%%
%%      ,      
%%    ( ,    ).
%%           ,
%%          .
%%
%%10. ,     XeLaTeX, LuaLaTeX  polyglossia.
%%           babel.
%%           .
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\NeedsTeXFormat{LaTeX2e}[1995/12/01]
\ProvidesClass{mon2017dev}
  [2018/04/09 v0.02 vakthesis support document class (OMB)]
\LoadClassWithOptions{vakthesis}[2009/04/01]
%   v0.3  2014/05/04 
% \RenewEnviron  ,     environ.
\RequirePackage{environ}[2014/05/04]
%        ,
%   \captions<languagename> ( babel).
%         babel,
%   \@title  .
%     ( \title    ),
%     \captionsenglish  \captionsukrainian.
% TODO: 1.   .
%      䳿 ,
%       
%      .
%    (\author, '  speciality, ...)   ,
%      .
% 2.  ,     babel  ,
%      translations, translator .
% TODO: ,         polyglossia
% ( babel   XeLaTeX  LuaLaTeX),
%      babel.
%     XeLaTeX  LuaLaTeX,
%       .
\renewcommand{\title}[1]{%
  \iflanguage{\bbl@main@language}{%
    \gdef\@title{#1}%
  }{%
    \expandafter\addto\csname captions\languagename\endcsname{%
      \def\@title{#1}%
    }%
  }%
}
\renewcommand{\author}[1]{%
  \iflanguage{\bbl@main@language}{%
    \gdef\@author{#1}%
    \gdef\@shortauthor{\@shortifyname#1\@nil}%
    \gdef\shortauthor@{\shortifyname@#1\@nil}%
  }{%
    \expandafter\addto\csname captions\languagename\endcsname{%
      \def\@author{#1}%
      \def\@shortauthor{\@shortifyname#1\@nil}%
      \def\shortauthor@{\shortifyname@#1\@nil}%
    }%
  }%
}
%  '   ,   
\def\@shortifyname#1 #2 #3\@nil{%
  \@shortify@name#2\@nil
  \@shortify@name#3\@nil
  #1%
}
\def\@shortify@name#1#2\@nil{#1.~}
%  '   ,   
\def\shortifyname@#1 #2 #3\@nil{%
  #1%
  \shortify@name@#2\@nil
  \shortify@name@#3\@nil
}
\def\shortify@name@#1#2\@nil{~#1.}
%  
\renewcommand{\supervisor}[2]{%
  \stepcounter{@supervisors@count}%
  \ifnum\value{@supervisors@count}=1
    \iflanguage{\bbl@main@language}{%
      \gdef\@supervisors{\\{#1}{#2}}%
    }{%
      \expandafter\addto\csname captions\languagename\endcsname{%
% REVIEW:    ?
        \gdef\@supervisors{\\{#1}{#2}}%
      }%
    }%
    % \def\@supervisors{\\{#1}{#2}}%
  \else
    \iflanguage{\bbl@main@language}{%
      \g@addto@macro\@supervisors{\\{#1}{#2}}%
    }{%
      \expandafter\addto\csname captions\languagename\endcsname{%
        \g@addto@macro\@supervisors{\\{#1}{#2}}%
      }%
    }%
    % \g@addto@macro\@supervisors{\\{#1}{#2}}%
  \fi
}
%    
\def\n@speciality[#1]{%
  \iflanguage{\bbl@main@language}{%
    \gdef\@specialityname{#1}%
  }{%
    \expandafter\addto\csname captions\languagename\endcsname{%
      \def\@specialityname{#1}%
    }%
  }%
  % \def\@specialityname{#1}%
  \@speciality}
\def\@speciality#1{%
  \@parse@speciality#1.\@nil
%     ,     
% (.  \n@specialitya).
  \iflanguage{\bbl@main@language}{%
    \gdef\@specialitycode{\@speca.\@specb.\@specc}%
  }{%
    \expandafter\addto\csname captions\languagename\endcsname{%
      \def\@specialitycode{\@speca.\@specb.\@specc}%
    }%
    \def\@specialitycode{\@speca.\@specb.\@specc}%
  }%
  % \def\@specialitycode{\@speca.\@specb.\@specc}%
  \@ifnextchar[\ns@speciality\s@specialitya}
\def\ns@speciality[#1]{%
  \iflanguage{\bbl@main@language}{%
    \gdef\@science{#1}%
  }{%
    \expandafter\addto\csname captions\languagename\endcsname{%
      \def\@science{#1}%
    }%
  }%
  % \def\@science{#1}%
}
\def\s@specialitya{%
  \@find@speciality
  \iflanguage{\bbl@main@language}{%
    \gdef\@science{\expandafter\@afterslash\@found\@nil}%
  }{%
    \expandafter\addto\csname captions\languagename\endcsname{%
      \def\@science{\expandafter\@afterslash\@found\@nil}%
    }%
  }%
  % \def\@science{\expandafter\@afterslash\@found\@nil}%
}
\def\n@specialitya#1{%
  \@parse@speciality#1.\@nil
%     ,     
% (.  \@speciality).
  \iflanguage{\bbl@main@language}{%
    \gdef\@specialitycode{\@speca.\@specb.\@specc}%
  }{%
    \expandafter\addto\csname captions\languagename\endcsname{%
      \def\@specialitycode{\@speca.\@specb.\@specc}%
    }%
    \def\@specialitycode{\@speca.\@specb.\@specc}%
  }%
  % \def\@specialitycode{\@speca.\@specb.\@specc}%
  \@ifnextchar[\s@speciality\ns@specialitya}
\def\s@speciality[#1]{%
  \iflanguage{\bbl@main@language}{%
    \gdef\@science{#1}%
  }{%
    \expandafter\addto\csname captions\languagename\endcsname{%
      \def\@science{#1}%
    }%
  }%
  % \def\@science{#1}%
  \@find@speciality
  \iflanguage{\bbl@main@language}{%
    \gdef\@specialityname{\expandafter\@beforeslash\@found\@nil}%
  }{%
    \expandafter\addto\csname captions\languagename\endcsname{%
      \def\@specialityname{\expandafter\@beforeslash\@found\@nil}%
    }%
  }%
  % \def\@specialityname{\expandafter\@beforeslash\@found\@nil}%
}
\def\ns@specialitya{%
  \@find@speciality
  \iflanguage{\bbl@main@language}{%
    \gdef\@specialityname{\expandafter\@beforeslash\@found\@nil}%
    \gdef\@science{\expandafter\@afterslash\@found\@nil}%
  }{%
    \expandafter\addto\csname captions\languagename\endcsname{%
      \def\@specialityname{\expandafter\@beforeslash\@found\@nil}%
      \def\@science{\expandafter\@afterslash\@found\@nil}%
    }%
  }%
  % \def\@specialityname{\expandafter\@beforeslash\@found\@nil}%
  % \def\@science{\expandafter\@afterslash\@found\@nil}%
}
\def\@parse@speciality#1.#2.#3.#4\@nil{%
  \gdef\@speca{#1}%
  \gdef\@specb{#2}%
  \gdef\@specc{#3}}
\def\@test#1 #2\@nil{%
  \ifthenelse{\equal{\@required}{#1}}
  {\gdef\@found{#2}\let\next\relax}
  {}}
% ,   
\renewcommand{\institution}[2]{%
  \@split@institution#1,,\@nil
  \iflanguage{\bbl@main@language}{%
    \gdef\@towni{#2}%
  }{%
    \expandafter\addto\csname captions\languagename\endcsname{%
      \def\@towni{#2}%
    }%
  }%
  % \def\@town{#2}%
}
\def\@split@institution#1,#2,#3\@nil{%
  \iflanguage{\bbl@main@language}{%
    \gdef\@institution{#1}%
    \gdef\@institution@office{\ignorespaces#2}%
  }{%
    \expandafter\addto\csname captions\languagename\endcsname{%
      \def\@institution{#1}%
      \def\@institution@office{\ignorespaces#2}%
    }%
  }%
}
% ,    (  vakaref.cls      )
%%  
%% \council{ }[, ]{ }{}
\newcommand{\council}[1]{% \catcode`=11
  \def\@council@code{#1}%
  \@ifnextchar[\o@council\@council}
\def\o@council[#1,#2]#3#4{%
  \iflanguage{\bbl@main@language}{%
    \gdef\@council@institutiont{#1}%
    \gdef\@council@institutiont@office{\ignorespaces#2}%
  }{%
    \expandafter\addto\csname captions\languagename\endcsname{%
      \def\@council@institutiont{#1}%
      \def\@council@institutiont@office{\ignorespaces#2}%
    }%
  }%
  % \def\@council@institutiont{#1}%
  % \def\@council@institutiont@office{#2}%
  \@council{#3}{#4}}
\def\@council#1#2{%
  \iflanguage{\bbl@main@language}{%
    \gdef\@council@institution{#1}%
    \gdef\@council@address{#2}%
  }{%
    \expandafter\addto\csname captions\languagename\endcsname{%
      \def\@council@institution{#1}%
      \def\@council@address{#2}%
    }%
  }%
  % \def\@council@institution{#1}%
  % \def\@council@address{#2}%
  \@extracttown#2\@nil}
\def\@extracttown#1.#2,#3\@nil{%
  \iflanguage{\bbl@main@language}{%
    \global\def\@townc{\ignorespaces
      \@ifnextchar~{\@gobble}{\relax}#2}%
  }{%
    \expandafter\addto\csname captions\languagename\endcsname{%
      \global\def\@townc{\ignorespaces
        \@ifnextchar~{\@gobble}{\relax}#2}%
    }%
  }%
  % \global\def\@town{\ignorespaces
  %   \@ifnextchar~{\@gobble}{\relax}#2}%
}
\def\@council@code{<\cyrsh\cyri\cyrf\cyrr\ \cyrr\cyra\cyrd\cyri>}
\def\@council@institution{<\CYRN\cyra\cyrz\cyrv\cyra\ \cyru\cyrs\cyrt\cyra\cyrn\cyro\cyrv\cyri,
  \cyrv\ \cyrya\cyrk\cyrii\cyrishrt\ \cyrs\cyrt\cyrv\cyro\cyrr\cyre\cyrn\cyra\ \cyrr\cyra\cyrd\cyra>}
\def\@council@address{<\cyra\cyrd\cyrr\cyre\cyrs\cyra>}
%         .
%    ,   .
% (  vakaref.cls)
\newenvironment{listofpersons}[1]
  {\list{#1\hfil}{\topsep0pt\parsep0pt\itemsep.5\parskip
   \ifx\@supervisors\@empty
     \settowidth\@tempdima{#1}%
     \setlength\labelwidth{\@tempdima}%
   \else
     \settowidth\@tempdima{\@supervisors@caption}
     % \settowidth\@tempdimb{\@opponents@caption}
     % \ifdim\@tempdima>\@tempdimb
       \setlength\labelwidth{\@tempdima}%
     % \else
     %   \setlength\labelwidth{\@tempdimb}%
     % \fi
   \fi
   \setlength\leftmargin{\labelwidth}%
   \addtolength\leftmargin{\labelsep}%
   \def\makelabel##1{##1}%
   \def\makephantomlabel##1{\phantom{##1}}}%
   \rightskip\@flushglue% !   ,      
                        % ?   Underfull \hbox
  }
  {\endlist}
%      
\newcommand{\keywords}[1]{%
  \iflanguage{\bbl@main@language}{%
    \gdef\@keywords{#1}%
  }{%
    \expandafter\addto\csname captions\languagename\endcsname{%
      \def\@keywords{#1}%
    }%
  }%
}
%
\renewcommand\maketitle{\begin{titlepage}%
  \let\footnotesize\small
  \let\footnoterule\relax
  \let \footnote \thanks
  \@maketitle
  \end{titlepage}%
  \setcounter{footnote}{0}%
  \global\let\thanks\relax
  \global\let\maketitle\relax
  \global\let\@thanks\@empty
  \global\let\@author\@empty
  \global\let\@date\@empty
  % \global\let\@title\@empty
  \global\let\title\relax
  \global\let\author\relax
  \global\let\date\relax
  \global\let\and\relax
}
\def\@maketitle{%
  {\scshape
   \@ifundefined{@institution@office}{\relax}{\@institution@office\par}
   \@institution\par}
  \smallskip
  {\scshape
   \@ifundefined{@council@institutiont@office}{\relax}{\@council@institutiont@office\par}
   \@council@institutiont\par}
  % {\scshape\@council@institutiont@office\par\@council@institutiont\par}
  \vspace{\stretch{3}}%
% TODO:      .
  {\raggedleft
    \manuscriptname{\\}%
    \par}%
  \vspace{\stretch{2}}%
  {\bfseries\expandafter\emphsurname\@author \par}%
  \vspace{\stretch{2}}%
  {\raggedleft
    \@ifundefined{@secret}{}{%
      \@secret\\
      \CYRP\cyrr\cyri\cyrm.~\No~\placeholder[5mm]\\}
    \CYRU\CYRD\CYRK\ \@udc \par}%
  \vspace{\stretch{1}}%
  {\bfseries\scshape\CYRD\cyri\cyrs\cyre\cyrr\cyrt\cyra\cyrc\cyrii\cyrya\par}
  {\large\bfseries\scshape \@title \par}%
  \vspace{\stretch{1}}%
  \@specialitycode\ --- \@specialityname\par
  \vspace{\stretch{1}}%
% TODO: 1. ,   ,     ,
%   ,   
%   ,     ...
% (   speciality.20070212N70)?
%   :
% http://zakon.rada.gov.ua/go/z1133-11
% 2.  ,   speciality.20070212N70     .
%       (    ),
%   ,    .
%  - ,       (  ...).
% 3. , ,  :
%      ,
%       
% http://zakon.rada.gov.ua/go/266-2015-%D0%BF
%      ?
% 4. , ,   
%     --   ,
%   --   .
% .    (  ,  ).
% FIXME: ,     .   .
%   --    .
  % \@science\par
  \end{center}
  \vspace{\stretch{2}}%
  {\small%       ,  .
    %     
    \CYRP\cyro\cyrd\cyra\cyrie\cyrt\cyrsftsn\cyrs\cyrya\
    \cyrn\cyra\ \cyrz\cyrd\cyro\cyrb\cyru\cyrt\cyrt\cyrya\
    \cyrn\cyra\cyru\cyrk\cyro\cyrv\cyro\cyrg\cyro\
    \cyrs\cyrt\cyru\cyrp\cyre\cyrn\cyrya\
% TODO:     =  ,
%         ?
    \degreename\cyra\
    \@science\unskip.
    %     .
    \CYRD\cyri\cyrs\cyre\cyrr\cyrt\cyra\cyrc\cyrii\cyrya\
    \cyrm\cyrii\cyrs\cyrt\cyri\cyrt\cyrsftsn\
    \cyrr\cyre\cyrz\cyru\cyrl\cyrsftsn\cyrt\cyra\cyrt\cyri\
    \cyrv\cyrl\cyra\cyrs\cyrn\cyri\cyrh\
    \cyrd\cyro\cyrs\cyrl\cyrii\cyrd\cyrzh\cyre\cyrn\cyrsftsn.
    %  ,           
    \CYRV\cyri\cyrk\cyro\cyrr\cyri\cyrs\cyrt\cyra\cyrn\cyrn\cyrya\
    \cyrii\cyrd\cyre\cyrishrt,
    \cyrr\cyre\cyrz\cyru\cyrl\cyrsftsn\cyrt\cyra\cyrt\cyrii\cyrv\
    \cyrii\
    \cyrt\cyre\cyrk\cyrs\cyrt\cyrii\cyrv\
    \cyrii\cyrn\cyrsh\cyri\cyrh\
    \cyra\cyrv\cyrt\cyro\cyrr\cyrii\cyrv\
    \cyrm\cyra\cyryu\cyrt\cyrsftsn\
    \cyrp\cyro\cyrs\cyri\cyrl\cyra\cyrn\cyrn\cyrya\
    \cyrn\cyra\
    \cyrv\cyrii\cyrd\cyrp\cyro\cyrv\cyrii\cyrd\cyrn\cyre\
    \cyrd\cyrzh\cyre\cyrr\cyre\cyrl\cyro.
    % \newline
    \placeholder[25mm]
    \@shortauthor\par}
  \vspace{\stretch{2}}%
  {% \raggedleft
   % \noindent
   \let\\\@format@person
   % \ifx\@supervisors\@empty
   %   \hbox{}\hbox{}\hbox{}
   % \else
   %   \@supervisors@caption\@supervisors\relax
   % \fi
   \ifx\@supervisors\@empty
   \else
     \begin{listofpersons}{\@supervisors@caption}
       \@supervisors\relax
     \end{listofpersons}
   \fi
   % \par
  }%
  \vspace{\stretch{3}}%
  \begin{center}
  \@towni\ --- \@year}
\def\@supervisors@caption{%
  \ifnum\value{@supervisors@count}>1
    \manysupervisorsname:%
  \else
    \onesupervisorname:%
  \fi}
\def\@format@person#1#2{\item
  \textbf{#1}, \linebreak[1]\@@format@person#2,,\@nil
  \let\makelabel\makephantomlabel
  \futurelet\next\@delimit@person}
% ,   /  
\newcommand\makeabstract{%
  \begin{abstractpage}%
    \@makeabstract{ukrainian}%
    \@makeabstract{english}%
  \end{abstractpage}%
}
\def\@makeabstract#1{%
  \begin{otherlanguage}{#1}
    \emph{\shortauthor@}
    \@title.
    \cdash---
    \manuscriptname{\relax}.
    \par
    \thesisdescriptionname{\degreename}{\@science}{\@specialitycode}{\@specialityname}.
    \cdash---
    \@institution;
    \@council@institution,
    \@towni,
    \@year.
    \par
    \smallskip
    \@abstract
    \par
    \smallskip
    \emph{\keywordsname}:
    \@keywords.
    \par
    \bigskip
  \end{otherlanguage}%
}
% г ,     :
% 1.
% \newbox\abstractbox
% \renewenvironment{abstract}{%
%   \global\setbox\abstractbox=\vtop\bgroup
% }{%
%   \egroup
%   \iflanguage{\bbl@main@language}{%
%     \gdef\@abstractboxcontent{\box\abstractbox}%
%   }{%
%     \expandafter\addto\csname captions\languagename\endcsname{%
%       \def\@abstractboxcontent{\box\abstractbox}%
%     }%
%   }%
% }
% \newsavebox{\abstractbox}
% \savebox{\abstractbox}{12345}
% \renewenvironment{abstract}{%
%   \savebox{\abstractbox}\bgroup
% }{%
%   \egroup
%   \def\@abstractboxcontent{\usebox{\abstractbox}}%
%   \iflanguage{\bbl@main@language}{%
%     \gdef\@abstractboxcontent{\usebox{\abstractbox}}%
%   }{%
%     \expandafter\addto\csname captions\languagename\endcsname{%
%       \def\@abstractboxcontent{\usebox{\abstractbox}}%
%     }%
%   }%
% }
% 2.
% https://tex.stackexchange.com/questions/70016/ways-to-grab-and-store-larger-amount-of-text
% https://tex.stackexchange.com/questions/49129/lrbox-in-newenvironment
% \long\def\abstract#1\endabstract{\def\@abstractboxcontent{#1}}
% \let\endabstract\relax
% \newsavebox{\abstractbox}
% \renewenvironment{abstract}{%
%   \lrbox{0\null\global\setbox\abstractbox}%
% }{%
%   \endlrbox
%   \xdef\@abstractboxcontent\expandafter{\usebox{\abstractbox}}%
% }
%       environ.
%
%  environ   v0.3  쳺  ,
%     .
%      ,
%        environ,
%      .
%     ,
%         environ.
% \let\abstract\relax
% \let\endabstract\relax
% \NewEnviron{abstract}{}
\RenewEnviron{abstract}{%
  \iflanguage{\bbl@main@language}{%
    \xdef\@abstract{\BODY}%
  }{%
    \expandafter\g@addto@macro\csname captions\languagename\expandafter\endcsname\expandafter{%
      \expandafter\def\expandafter\@abstract\expandafter{\BODY}%
    }%
  }%
}
%
\newenvironment{abstractpage}{%
  % \chapter*{\abstractname}%
  %       .
  % REVIEW:   \tableofcontents.
  %   .
  \@tocheader{%
    \abstractname
    \@mkboth{\MakeUppercase\abstractname}{\MakeUppercase\abstractname}%
  }%
}{%
%
}
%        .
% TODO:   approval  ?
% https://en.wiktionary.org/wiki/approval
% https://en.wiktionary.org/wiki/approbation
% https://e2u.org.ua/s?w=%D0%B0%D0%BF%D1%80%D0%BE%D0%B1%D0%B0%D1%86%D1%96%D1%8F&dicts=all&highlight=on&filter_lines=on
\NewEnviron{approval}[1][\approvalname]{%
  \paragraph{#1}%
  \global\let\sav@approval\BODY
  \BODY
}
\newcommand{\repeatapproval}{%
  \def\approvalname{%
    % ³    
    {\cyr\CYRV\cyrii\cyrd\cyro\cyrm\cyro\cyrs\cyrt\cyrii\
      \cyrp\cyrr\cyro\
      \cyra\cyrp\cyrr\cyro\cyrb\cyra\cyrc\cyrii\cyryu\
      \cyrr\cyre\cyrz\cyru\cyrl\cyrsftsn\cyrt\cyra\cyrt\cyrii\cyrv\
      \cyrd\cyri\cyrs\cyre\cyrr\cyrt\cyra\cyrc\cyrii\cyryi}%
  }%
  \renewcommand{\participation}[1]{\unskip, ##1}%
  \section{\approvalname}%
  \sav@approval
}
\def\approvalname{%
  %   
  {\cyr\CYRA\cyrp\cyrr\cyro\cyrb\cyra\cyrc\cyrii\cyrya\
    \cyrm\cyra\cyrt\cyre\cyrr\cyrii\cyra\cyrl\cyrii\cyrv\
    \cyrd\cyri\cyrs\cyre\cyrr\cyrt\cyra\cyrc\cyrii\cyryi}%
}%
% ֳ      .
%    ,     ,    -- .
\newcommand{\participation}[1]{\unskip}
%   
%    ,  
\newenvironment{authorpublications}[1]
     {% \chapter*{\bibname}%
      % \@mkboth{\MakeUppercase\bibname}{\MakeUppercase\bibname}%
      \list{\@biblabel{\@arabic\c@enumiv\@bibmark}}%
           {\settowidth\labelwidth{\@biblabel{#1\@bibmark}}%
            \leftmargin\labelwidth
            \advance\leftmargin\labelsep
            \@openbib@code
            \usecounter{enumiv}%
            \let\p@enumiv\@empty
            \renewcommand\theenumiv{\@arabic\c@enumiv\@bibmark}}%
      \sloppy
      \clubpenalty4000
      \@clubpenalty \clubpenalty
      \widowpenalty4000%
     }
     {\def\@noitemerr
       {\@latex@warning{Empty `thebibliography' environment}}%
      \endlist}
%    ,  
\newenvironment{reauthorpublications}[1]
     {\section{\bibname}%
      % \@mkboth{\MakeUppercase\bibname}{\MakeUppercase\bibname}%
      \list{\@biblabel{\@arabic\c@enumiv\@bibmark}}%
           {\settowidth\labelwidth{\@biblabel{#1\@bibmark}}%
            \leftmargin\labelwidth
            \advance\leftmargin\labelsep
            \@openbib@code
            \usecounter{enumiv}%
            \let\p@enumiv\@empty
            \renewcommand\theenumiv{\@arabic\c@enumiv\@bibmark}}%
      \sloppy
      \clubpenalty4000
      \@clubpenalty \clubpenalty
      \widowpenalty4000%
     }
     {\def\@noitemerr
       {\@latex@warning{Empty `thebibliography' environment}}%
      \endlist}
%    .
%  ,    ,  \list, \endlist.
% ,      .
%      ,   .
%       .bbl- (  ).
% TODO:  ,   .bbl-   .tex-?
%             ,  BibTeX?
%           .
% TODO:        (.  .),
%           ?
% \NewEnviron{thepublications}[1]
%      {% \chapter*{\bibname}%
%       % \@mkboth{\MakeUppercase\bibname}{\MakeUppercase\bibname}%
%       \list{\@biblabel{\@arabic\c@enumiv\@bibmark}}%
%            {\settowidth\labelwidth{\@biblabel{#1\@bibmark}}%
%             \leftmargin\labelwidth
%             \advance\leftmargin\labelsep
%             \@openbib@code
%             \usecounter{enumiv}%
%             \let\p@enumiv\@empty
%             \renewcommand\theenumiv{\@arabic\c@enumiv\@bibmark}}%
%       \sloppy
%       \clubpenalty4000
%       \@clubpenalty \clubpenalty
%       \widowpenalty4000%
%       \global\let\sav@publications\BODY
%       \BODY
%      }
%      [\def\@noitemerr
%        {\@latex@warning{Empty `thepublications' environment}}%
%       \endlist]
% \newcommand{\repeatpublications}{%
%       \chapter*{\bibname}%
%       \@mkboth{\MakeUppercase\bibname}{\MakeUppercase\bibname}%
%       \list{\@biblabel{\@arabic\c@enumiv\@bibmark}}%
%            {\settowidth\labelwidth{\@biblabel{AA\@bibmark}}%
%             \leftmargin\labelwidth
%             \advance\leftmargin\labelsep
%             \@openbib@code
%             \usecounter{enumiv}%
%             \let\p@enumiv\@empty
%             \renewcommand\theenumiv{\@arabic\c@enumiv\@bibmark}}%
%       \sloppy
%       \clubpenalty4000
%       \@clubpenalty \clubpenalty
%       \widowpenalty4000%
%   \sav@publications% !!!
%      \def\@noitemerr
%        {\@latex@warning{Empty `thebibliography' environment}}%
%       \endlist}
\newcommand{\repeatauthorpublications}{%
  \def\bibname{%      
    {\cyr\CYRS\cyrp\cyri\cyrs\cyro\cyrk\
      \cyrp\cyru\cyrb\cyrl\cyrii\cyrk\cyra\cyrc\cyrii\cyrishrt\
      \cyrz\cyrd\cyro\cyrb\cyru\cyrv\cyra\cyrch\cyra\
      \cyrz\cyra\
      \cyrt\cyre\cyrm\cyro\cyryu\
      \cyrd\cyri\cyrs\cyre\cyrr\cyrt\cyra\cyrc\cyrii\cyryi}}%
  \let\thebibliography\reauthorpublications
  \let\endthebibliography\endreauthorpublications
  \let\@lbibitem\simple@lbibitem
  \let\@bibitem\simple@bibitem
  \@input@{\jobname1.bbl}%
}
%  \bibitem,   ,      .
%   multiply-defined labels.
\def\simple@lbibitem[#1]#2{\item[\@biblabel{#1}\hfill]\ignorespaces}
\def\simple@bibitem#1{\item\ignorespaces}
%      authorpublications.
\renewenvironment{bibset}[2][]
  {\stepcounter{currbibset}%
   \def\@temp{#1}%
   \ifx\@temp\@empty
     \def\@bibmark{\relax}%FIXME: \def\@bibmark{}  
   \else
     \def\@bibmark{\textsuperscript{#1}}%
   \fi
   \let\@sav@lbibitem\@lbibitem
   \def\@lbibitem[##1]##2{\@sav@lbibitem[##1\@bibmark]{##2}}%
   \@ifundefined{hyper@warn}
%%     hyperref
     {\def\@bibitem##1{\item\if@filesw \immediate\write\@auxout
        {\string\bibcite{##1}{\the\value{\@listctr}\expandafter\string\@bibmark}}%
        \fi\ignorespaces}}
%%    hyperref
     {\def\@bibitem##1{%
      \@skiphyperreftrue\H@item\@skiphyperreffalse
      \hyper@anchorstart{cite.##1}\relax\hyper@anchorend
      \if@filesw {\let\protect\noexpand
      \immediate\write\@auxout{%
        \string\bibcite{##1}{\the\value{\@listctr}\expandafter\string\@bibmark}}}%
      \fi
      \ignorespaces}}%
   \def\bibname{#2}%
   \let\bibliography\@thisbibliography
   \let\bibliographystyle\@thisbibliographystyle
%  ,       .
   \ifnum\thecurrbibset=1
     \let\thebibliography\authorpublications
     \let\endthebibliography\endauthorpublications
     \let\@lbibitem\simple@lbibitem
     \let\@bibitem\simple@bibitem
   \fi}
  {\ifnum\thecurrbibset=\theneedbibset
     \ifnum\theneedbibset=1
       \immediate\write\@auxout{\string\setcounter{needbibset}{2}}%
     \else
       \immediate\write\@auxout{\string\setcounter{needbibset}{1}}%
     \fi
   \fi}
%   (  )
% TODO:     .
%    ,    .
%   ,     -- ukrainian,
%     .
%       
% ( english --   ).
\AtBeginDocument{%
\if@cthesis
  \addto\captionsenglish{\def\degreename{candidate}}%
  \addto\captionsukrainian{\def\degreename{\cyrk\cyra\cyrn\cyrd\cyri\cyrd\cyra\cyrt}}%
\else
  \addto\captionsenglish{\def\degreename{doctor}}%
  \addto\captionsukrainian{\def\degreename{\cyrd\cyro\cyrk\cyrt\cyro\cyrr}}%
\fi
\addto\captionsenglish{%
  \def\manuscriptname#1{%
    % FIXME: Qualification  Qualifying?
    Qualification scientific work#1 in the form of manuscript%
  }%
  \def\thesisdescriptionname#1#2#3#4{%
    Thesis for #1 degree
    in #2
    (doctor of philosophy),
    % TODO:   speciality --    .
    %      --  .
    %  :      speciality?
    %       ,
    %        \speciality.
    speciality #3 ``#4''%
    % TODO:   ,   .
    %    ,   .
    %      .
    % FIXME: ,     .   .
    %   --    .
    % \ (012 \cdash--- Preschool education)%
  }%
  \def\keywordsname{Key words}%
}
\addto\captionsukrainian{%
  \def\manuscriptname#1{%
    %      
    \CYRK\cyrv\cyra\cyrl\cyrii\cyrf\cyrii\cyrk\cyra\cyrc\cyrii\cyrishrt\cyrn\cyra\
    \cyrn\cyra\cyru\cyrk\cyro\cyrv\cyra#1
    \cyrp\cyrr\cyra\cyrc\cyrya\
    \cyrn\cyra\
    \cyrp\cyrr\cyra\cyrv\cyra\cyrh\
    \cyrr\cyru\cyrk\cyro\cyrp\cyri\cyrs\cyru
  }%
  \def\thesisdescriptionname#1#2#3#4{%
    %     
    %    ( )
    \CYRD\cyri\cyrs\cyre\cyrr\cyrt\cyra\cyrc\cyrii\cyrya\
    \cyrn\cyra\
    \cyrz\cyrd\cyro\cyrb\cyru\cyrt\cyrt\cyrya\
    \cyrn\cyra\cyru\cyrk\cyro\cyrv\cyro\cyrg\cyro\
    \cyrs\cyrt\cyru\cyrp\cyre\cyrn\cyrya\
    #1\cyra\
    #2
    (\cyrd\cyro\cyrk\cyrt\cyro\cyrr\cyra\
    \cyrf\cyrii\cyrl\cyro\cyrs\cyro\cyrf\cyrii\cyryi)
    \cyrz\cyra\
    \cyrs\cyrp\cyre\cyrc\cyrii\cyra\cyrl\cyrsftsn\cyrn\cyrii\cyrs\cyrt\cyryu\
    #3
    % TODO:   speciality --    .
    %      --  .
    %  :      speciality?
    <<#4>>%
    % TODO:   ,   .
    %    ,   .
    %      .
    % FIXME: ,     .   .
    %   --    .
    % \ (012
    % \cdash---
    % \CYRD\cyro\cyrsh\cyrk\cyrii\cyrl\cyrsftsn\cyrn\cyra\
    % \cyro\cyrs\cyrv\cyrii\cyrt\cyra)%
  }%
  \def\keywordsname{\CYRK\cyrl\cyryu\cyrch\cyro\cyrv\cyrii\ \cyrs\cyrl\cyro\cyrv\cyra}%
}
}
\endinput
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Local Variables:
% mode: latex
% coding: windows-1251-dos
% End:
